##-*- Mode: CPerl -*-

## File: Pd/Patch/array.pm
## Author: Bryan Jurish <moocow@ling.uni-potsdam.de>
## Description:
##  + class for Pd canvas arrays
##======================================================================

##======================================================================
## array: package
##
## + additional attributes: {_data} => $dataItem,
##
package Pd::Patch::X_array;
use Pd::Patch::Item;
our @ISA = qw(Pd::Patch::Item);
sub PROPERTIES { return [qw(decl type name size float flags)]; }
sub DEFAULTS { return {decl=>'#X', type=>'array', size=>100, float=>'float', flags=>3}; }
__PACKAGE__->init();

##-- 'flags' construction: ?!

##-- aliases
@Pd::Patch::array::ISA = (__PACKAGE__);
@Pd::Patch::Array::ISA = (__PACKAGE__);

sub loadData {
  my ($a,$lines) = @_;
  return $a if (!$lines || !@$lines || $lines->[0] !~ /^\#A\s/);
  $a->{_data} = Pd::Patch::Item->loadLines($lines);
  return $a;
}
sub saveLines {
  my $a = shift;
  return [
	  @{$a->SUPER::saveLines()},
	  (defined($a->{_data})
	   ? @{$a->{_data}->saveLines()}
	   : qw()),
	 ];
}

1; ##-- be happy

__END__

##======================================================================
## Docs
=pod

=head1 NAME

Pd::Patch - Perl parser and wrapper classes for Pd abstractions

=head1 SYNOPSIS

 use Pd::Patch;

 #... stuff happens...

=cut

##======================================================================
## Description
=pod

=head1 DESCRIPTION

not yet written

=cut

##======================================================================
## Footer
=pod

=head1 ACKNOWLEDGEMENTS

perl by Larry Wall.

Pd by Miller Puckette and others.

=head1 AUTHOR

Bryan Jurish E<lt>moocow@ling.uni-potsdam.deE<gt>

=head1 COPYRIGHT

Copyright (c) 2007, Bryan Jurish.  All rights reserved.

This package is free software.  You may redistribute it
and/or modify it under the same terms as Perl itself.

=head1 SEE ALSO

perl(1),
pd(1).

=cut
